/***********************************************************
 * $Id$
 *
 * FancyLibs GPSD Client
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSPSDCLIENTMESSAGE_H_
#define FANCYSPSDCLIENTMESSAGE_H_

#include <fancygpsdclient.h>
#include <fancyserializable.h>

namespace Fancy {
namespace GpsdClient {

/**
 * Abstract base class for the JSON-serialized messages retrieved from gpsd.
 */
class FANCYGPSDCLIENT_API Message : public Fancy::Serializable {

public:
	typedef Fancy::ObjPtr<Message> ptr_t;

	static const char *getSerialID_s();
	const char *getSerialID() const;

	std::string toString() const;

protected:
	Message();
	virtual ~Message();
};

} /* namespace GpsdClient */
} /* namespace Fancy */

#endif /* FANCYSPSDCLIENTMESSAGE_H_ */
